# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ContainerService::Mgmt::V2017_08_31
  module Models
    #
    # Information about a service principal identity for the cluster to use for
    # manipulating Azure APIs. Either secret or keyVaultSecretRef must be
    # specified.
    #
    class ContainerServiceServicePrincipalProfile

      include MsRestAzure

      # @return [String] The ID for the service principal.
      attr_accessor :client_id

      # @return [String] The secret password associated with the service
      # principal in plain text.
      attr_accessor :secret

      # @return [KeyVaultSecretRef] Reference to a secret stored in Azure Key
      # Vault.
      attr_accessor :key_vault_secret_ref


      #
      # Mapper for ContainerServiceServicePrincipalProfile class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ContainerServiceServicePrincipalProfile',
          type: {
            name: 'Composite',
            class_name: 'ContainerServiceServicePrincipalProfile',
            model_properties: {
              client_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'clientId',
                type: {
                  name: 'String'
                }
              },
              secret: {
                client_side_validation: true,
                required: false,
                serialized_name: 'secret',
                type: {
                  name: 'String'
                }
              },
              key_vault_secret_ref: {
                client_side_validation: true,
                required: false,
                serialized_name: 'keyVaultSecretRef',
                type: {
                  name: 'Composite',
                  class_name: 'KeyVaultSecretRef'
                }
              }
            }
          }
        }
      end
    end
  end
end
