# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ContainerService::Mgmt::V2019_09_30_preview
  module Models
    #
    # OpenShiftManagedClusterMaterPoolProfile contains configuration for
    # OpenShift master VMs.
    #
    class OpenShiftManagedClusterMasterPoolProfile

      include MsRestAzure

      # @return [String] Unique name of the master pool profile in the context
      # of the subscription and resource group.
      attr_accessor :name

      # @return [Integer] Number of masters (VMs) to host docker containers.
      # The default value is 3.
      attr_accessor :count

      # @return [OpenShiftContainerServiceVMSize] Size of agent VMs. Possible
      # values include: 'Standard_D2s_v3', 'Standard_D4s_v3',
      # 'Standard_D8s_v3', 'Standard_D16s_v3', 'Standard_D32s_v3',
      # 'Standard_D64s_v3', 'Standard_DS4_v2', 'Standard_DS5_v2',
      # 'Standard_F8s_v2', 'Standard_F16s_v2', 'Standard_F32s_v2',
      # 'Standard_F64s_v2', 'Standard_F72s_v2', 'Standard_F8s',
      # 'Standard_F16s', 'Standard_E4s_v3', 'Standard_E8s_v3',
      # 'Standard_E16s_v3', 'Standard_E20s_v3', 'Standard_E32s_v3',
      # 'Standard_E64s_v3', 'Standard_GS2', 'Standard_GS3', 'Standard_GS4',
      # 'Standard_GS5', 'Standard_DS12_v2', 'Standard_DS13_v2',
      # 'Standard_DS14_v2', 'Standard_DS15_v2', 'Standard_L4s', 'Standard_L8s',
      # 'Standard_L16s', 'Standard_L32s'
      attr_accessor :vm_size

      # @return [String] Subnet CIDR for the peering.
      attr_accessor :subnet_cidr

      # @return [OSType] OsType to be used to specify os type. Choose from
      # Linux and Windows. Default to Linux. Possible values include: 'Linux',
      # 'Windows'. Default value: 'Linux' .
      attr_accessor :os_type


      #
      # Mapper for OpenShiftManagedClusterMasterPoolProfile class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'OpenShiftManagedClusterMasterPoolProfile',
          type: {
            name: 'Composite',
            class_name: 'OpenShiftManagedClusterMasterPoolProfile',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              count: {
                client_side_validation: true,
                required: true,
                serialized_name: 'count',
                type: {
                  name: 'Number'
                }
              },
              vm_size: {
                client_side_validation: true,
                required: true,
                serialized_name: 'vmSize',
                type: {
                  name: 'String'
                }
              },
              subnet_cidr: {
                client_side_validation: true,
                required: false,
                serialized_name: 'subnetCidr',
                type: {
                  name: 'String'
                }
              },
              os_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'osType',
                default_value: 'Linux',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
