# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ContainerService::Mgmt::V2020_06_01
  module Models
    #
    # Identity for the managed cluster.
    #
    class ManagedClusterIdentity

      include MsRestAzure

      # @return [String] The principal id of the system assigned identity which
      # is used by master components.
      attr_accessor :principal_id

      # @return [String] The tenant id of the system assigned identity which is
      # used by master components.
      attr_accessor :tenant_id

      # @return [ResourceIdentityType] The type of identity used for the
      # managed cluster. Type 'SystemAssigned' will use an implicitly created
      # identity in master components and an auto-created user assigned
      # identity in MC_ resource group in agent nodes. Type 'None' will not use
      # MSI for the managed cluster, service principal will be used instead.
      # Possible values include: 'SystemAssigned', 'UserAssigned', 'None'
      attr_accessor :type

      # @return [Hash{String =>
      # ManagedClusterIdentityUserAssignedIdentitiesValue}] The user identity
      # associated with the managed cluster. This identity will be used in
      # control plane and only one user assigned identity is allowed. The user
      # identity dictionary key references will be ARM resource ids in the
      # form:
      # '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}'.
      attr_accessor :user_assigned_identities


      #
      # Mapper for ManagedClusterIdentity class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ManagedClusterIdentity',
          type: {
            name: 'Composite',
            class_name: 'ManagedClusterIdentity',
            model_properties: {
              principal_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'principalId',
                type: {
                  name: 'String'
                }
              },
              tenant_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'tenantId',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'type',
                type: {
                  name: 'Enum',
                  module: 'ResourceIdentityType'
                }
              },
              user_assigned_identities: {
                client_side_validation: true,
                required: false,
                serialized_name: 'userAssignedIdentities',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ManagedClusterIdentityUserAssignedIdentitiesValueElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ManagedClusterIdentityUserAssignedIdentitiesValue'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
